<?php


/* 
 * Admin menu for ELiS Library
 * @author Arsen I. Borovinskiy
 */

function elis_sendfile_admin_settings_form($form) {
  $form = array();
  $default_value = variable_get('elis_sendfile_remove_timeout', '7 days');
  $form['elis_sendfile_remove_timeout'] = array(
    '#type' => 'textfield',
    '#title' => 'Remove files timeout after creation',
    '#required' => FALSE,
    '#default_value' => $default_value,
    '#description' => 'Через какой время после создания ноды sendfile она и загруженные файлы будут удалены. Надо писать объем времени и единицу измерения. Разрешены дни (days) и часы (hours). Примеры: 7 days, 8 hours, 14 days, 1 day. По-умолчанию 7 days.',
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => 'Submit',
  );
  return $form;
}

function elis_sendfile_admin_settings_form_validate($form,&$form_state) {
  $form_state['cache'] = FALSE;
  if (isset($form_state['values']['elis_sendfile_remove_timeout']) && preg_match("/^(\d+)\s((days?)|(hours?))$/", $form_state['values']['elis_sendfile_remove_timeout'], $matches)) {
    $count = $matches[1];
    $suffix = $matches[2];
    $date = new DateTime();
    $timestamp_now = $date->getTimestamp();
    $date->modify("-" . $form_state['values']['elis_sendfile_remove_timeout']);
    $timestamp_from = $date->getTimestamp();
    if (($timestamp_now - $timestamp_from) < 10) {
      form_set_error('elis_sendfile_remove_timeout','format must be like 7 days, 12 hours, 14 days, 1 hour');
    }
  } else {
    form_set_error('elis_sendfile_remove_timeout','format must be like 7 days, 12 hours, 14 days, 1 hour');
  }
}

function elis_sendfile_admin_settings_form_submit($form,$form_state) {
  variable_set('elis_sendfile_remove_timeout',$form_state['values']['elis_sendfile_remove_timeout']);
}